//**********************************
//   Żҥܥ塼+٥᡼
//   prosseccer=pic16f886-i/sp
//   ishizuka.yasuyuki
//   2011.08.22
//**********************************

#include <16f886.h>
#device adc=10
#fuses INTRC_IO,NOWDT,PUT,MCLR,NOPROTECT,NOCPD,BROWNOUT,IESO,FCMEN,NOLVP,NODEBUG,NOWRT,BORV40
#use delay(clock = 8000000)
#use fast_io(b)
#include <math.h>


//2100Ÿåɽ֡͡0.1á
//2101üҿ+1
//2102ܥ塼ɽˡ0:16С1:ʸ+30С2ʾ:064ο
//2103 ٥᡼1ܤʸ(L)
//2104 ٥᡼2ܤʸ(R)
//2105̵٥᡼˰ܹԤ֡͡0.1á
//2106٥᡼١ʽ63ȿ줬礭ʤ		쥯1
//2107٥᡼եåȡʽ0Υк			쥯1
//2108٥᡼١ʽ63ȿ줬礭ʤ		쥯2
//2109٥᡼եåȡʽ0Υк			쥯2
//210a٥᡼١ʽ63ȿ줬礭ʤ		쥯3
//210b٥᡼եåȡʽ0Υк			쥯3
//210c٥᡼١ʽ63ȿ줬礭ʤ		쥯4
//210d٥᡼եåȡʽ0Υк			쥯4
//            0    1    2    3    4    5    6    7    8    9    a    b    c    d    e    f
#rom 0x2100={0x32,0x01,0x01,0x4c,0x52,0x32,0x3f,0x00,0x3f,0x00,0x3f,0x00,0x3f,0x00,0xff,0xff}	//ѥ᡼
#rom 0x2110={0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff}	//쥸塼
#rom 0x2120={"www.zea.jp"}				//ѥonå1ܡ16ʸޤǵġ
#rom 0x2130={"     by Ishizuka"}			//ѥonå2ܡ16ʸޤǵġ
#rom 0x2140={"Rear:RCA"}				//쥯1ɽơ16ʸޤǵġ
#rom 0x2150={"Front:JACK"}				//쥯2ɽơ16ʸޤǵġ
#rom 0x2160={"input-3"}					//쥯3ɽơ16ʸޤǵġ
#rom 0x2170={"input-4"}					//쥯4ɽơ16ʸޤǵġ
#rom 0x2180={"Volume"}					//ʸ+30Сɽʸ6ʸޤǵġ6ʸʤϥڡ0x20Τȡ
#rom 0x2190={0x10,0x00,0x10,0x00,0x10,0x00,0x10,0x00,0x14,0x00,0x14,0x00,0x14,0x00,0x14,0x00}	//1Υåѥ:2Υåѥ
#rom 0x21a0={0x15,0x00,0x15,0x00,0x15,0x00,0x15,0x00,0x04,0x06,0x05,0x05,0x0d,0x1c,0x18,0x00}	//3Υåѥ:16ɽѥ饯
#rom 0x21b0={0x02,0x04,0x0e,0x15,0x11,0x11,0x0e,0x00,0x00,0x0a,0x0a,0x00,0x11,0x0e,0x00,0x00}	//ꥸʥ륭饯04:ꥸʥ륭饯05
#rom 0x21c0={0x00,0x18,0x18,0x18,0x18,0x18,0x1e,0x00,0x00,0x1c,0x1a,0x1a,0x1c,0x1a,0x1a,0x00}	//ꥸʥ륭饯06:ꥸʥ륭饯07
#rom 0x21d0={0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff}	//̤
#rom 0x21e0={0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff}	//̤
#rom 0x21f0={0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff}	//̤

#byte	osccon = 0x8f
#byte	iocb = 0x96
#byte	portc = 0x07

#define mute		pin_a3
#define select_sw	pin_b5
#define vol_data	pin_c4
#define vol_load	pin_c5
#define vol_clock	pin_c6
#define	portx 		portc
#define	en			pin_a7		//e
#define	rs			pin_a6		//rs

void io_init(void);				//
void cg_write(void);				//cg
void level_meter(void);				//٥᡼
int get_level(int ch);				//A/dѴȻ
void bAr_print(int ch, sig);			//
void trAns_rom(void);				//Ƽѥ᡼ǡž
void eeprom_disp(long add);			//eepromʸ
void work_disp(void);				//ǥϢ
void lm1972_data(void);				//Żҥܥ塼ѥǡù
void lm1972_send(int dat);			//Żҥܥ塼ICإǡž
void volume_disp(void);				//2ɽʥܥ塼٥
void select_port(void);				//selectorͤϡ
void select_disp(void);				//1ɽ
void vol_char(void);				//ܥ塼̣ͤʸɽ
short sw_check(void);				//٥᡼ɽSWǧ
void eeprom_rw(void);				//EEPROM꡼ɥ饤
void lcd_out(int code, int flag);		//LCDǡ
void lcd_data(int asci);			//LCD:ʸɽ
void lcd_cmd(int cmd);				//LCDޥɽ
void lcd_clear(void);				//LCDõ
void lcd_init(void);				//LCD


float bar_para;				//٥᡼ϴ
int bar_offset;				//٥᡼Υեå
int re_current;				//ɤ߹꡼󥳡ο
int re_previous;			//ɤ߹꡼󥳡ο
int re_step;				//꡼󥳡Υƥå׿
int volume;				//ܥ塼
int selector;				//򤵤
int sel_para;				//³Ͽ
int vol_code[6];			//̤̣ʸǼʺ6ʸ
long shift_cnt;				//٥᡼롼˰ܹԤޤǤΥ󥿡
long shift_set;				//٥᡼롼˰ܹԤޤǤΥ󥿡
int rb_last_read;			//٥᡼롼˰ܹԤľBݡȤξ
int vol_disp_sel;			//ܥ塼ɽˡ
int meter_car_f;			//٥᡼11ʸܤΥ饯
int meter_car_s;			//٥᡼21ʸܤΥ饯


#int_rtcc
void rtcc_isr()
{
	shift_cnt++;
}


void main (void)
{
	io_init();

	selector = read_eeprom(0x2110);			//ξ֤᤹
	volume = read_eeprom(0x2111);
	if(selector > 3)selector = 0;
	if(volume > 0x40)volume = 0;
	select_port();

	if(!read_eeprom(0x2100)==0)			//ɽ
	{
		int cnt;

		cnt = read_eeprom(0x2100);
		lcd_cmd(0x80);
		eeprom_disp(0x2120);
		lcd_cmd(0xc0);
		eeprom_disp(0x2130);
		while(cnt--)delay_ms(100);
	}

	delay_ms(50);
	lm1972_data();
	output_high(mute);
	lcd_clear();

	while(true)
	{
		shift_cnt = 0;						//٥᡼ɽܹԥ󥿡򥯥ꥢ
		re_step = 0;
		enable_interrupts(int_rtcc);				//󥿡Х륿ޡ

		for(;;)
		{
			work_disp();
			if(shift_cnt > shift_set && shift_set != 0)break;
		}

		rb_last_read = input_b() & 0b11100000;		//٥᡼롼ľ˥ݡBϿ
		disable_interrupts(int_rtcc);			//󥿡Х륿ޡ

		if(read_eeprom(0x2110) != selector)write_eeprom(0x2110,selector);	//ۤʤеƤ
		if(read_eeprom(0x2111) != volume)write_eeprom(0x2111,volume);		//ۤʤеƤ

		for(;;)
		{
			if(sw_check())break;
			level_meter();
		}
		lcd_clear();
	}
}


short sw_check(void)
{
	if(rb_last_read == (input_b() & 0b11100000))
	{
		return 0;
	}
	else
	{
		return 1;
	}
}


void work_disp(void)
{
	re_current = (input_b() & 0b11000000)>>6;						//꡼󥳡ɤ߹(bit7-6)

	if((re_previous == 0 && re_current == 1)|(re_current == 2 && re_previous == 3))		//cw
	{
		re_step++;
		if(re_step > 1)
		{
			re_step = 0;
			shift_cnt = 0;
			volume++;
			if(volume>0x40)volume = 0x40;
			lm1972_data();
		}
	}
	if((re_current == 0 && re_previous == 1)|(re_previous == 2 && re_current == 3))		//ccw
	{
		re_step++;
		if(re_step > 1)
		{
			re_step = 0;
			shift_cnt = 0;
			volume--;
			if(volume==0xff)volume = 0x00;
			lm1972_data();
		}
	}

	re_previous = re_current;

	if(! input(select_sw))
	{
		delay_ms(50);
		if(input(select_sw))break;
		shift_cnt = 0;
		selector++;
		if((selector > sel_para)||(selector > 3))selector = 0;
		select_port();
		select_disp();					//1ܤɽüҡ
		volume_disp();					//2ܤɽʥܥ塼͡
		while(! input(select_sw))shift_cnt = 0;
		delay_ms(50);
	}

	select_disp();			//1ܤɽüҡ
	volume_disp();			//2ܤɽʥܥ塼͡
	delay_ms(1);
}


void volume_disp(void)
{
	if(vol_disp_sel == 0)						//ܥ塼16ĤΥСɽ
	{
		int i,j;

		i = volume/4;						//64ʤ16
		if(i > 16)i = 16;					//max16ޤǤȤǰΤ
		j = 16 - i;						//ڡθĿ

		lcd_cmd(0xc0);						//2
		while(i--)lcd_data(0x03);				//iĤ"CG-ROM:0x03"񤭹ࡣ0ʤ񤭹ޤʤ
		while(j--)lcd_data(0x20);
	}

	if(vol_disp_sel == 1)						//ܥ塼򥭥饯30ĤΥСɽ
	{
		int v,i,j,k,m;

		v = volume/2;						//64ʤ32
		if(v > 30)v = 30;					//max30ޤǤȤ

		i = v/3;						//30ʤ10
		j = v-(i*3);						//1ˤʤ
		k = 9 - i;							//ڡϺǤ1褵Τ10-1=9
		m = i;

		lcd_cmd(0xc0);						//2
		vol_char();						//6ʸ

		while(m--)lcd_data(0x02);				//mĤ"|||"񤭹ࡣ0ʤ񤭹ޤʤ

		if(i < 10)						//i=15ʤХڡ񤭹ޤʤ
		{
			if(j == 0)lcd_data(0x20);			//ڡ
			if(j == 1)lcd_data(0x00);			//"|"
			if(j == 2)lcd_data(0x01);			//"||"
			while(k--)lcd_data(0x20);			//Ĥ򥹥ڡ
		}
	}

	if(vol_disp_sel > 1)						//ܥ塼͡064ˤɽ
	{
		lcd_cmd(0xc0);
		vol_char();
		printf(lcd_data,"%3u",volume);
	}
}


void lm1972_data(void)
{
	int i;

	i = 0x80 - volume * 2;

	output_low(vol_load);
	delay_cycles(2);
	lm1972_send(0x00);		//Rͥ
	lm1972_send(i);			//
	delay_cycles(2);
	output_high(vol_load);
	delay_cycles(2);
	output_low(vol_load);
	delay_cycles(2);
	lm1972_send(0x01);		//Lͥ
	lm1972_send(i);			//
	delay_cycles(2);
	output_high(vol_load);
}


void lm1972_send(int dat)
{
	int cnt;

	for(cnt=0;cnt<8;cnt++)
	{
		if(dat & 0x80)
		{
			output_high(vol_data);
		}
		else
		{
			output_low(vol_data);
		}
		delay_cycles(2);
		output_high(vol_clock);
		delay_cycles(2);
		output_low(vol_clock);
		dat = dat << 1;
	}
}


void select_port(void)
{
	if(selector == 0)
	{
		output_high(pin_b1);
		delay_ms(50);
		output_low(pin_b2);
		output_low(pin_b3);
		output_low(pin_b4);
		bar_para = read_eeprom(0x2106);		//٥᡼١:63
		bar_offset = read_eeprom(0x2107);	//٥᡼եåȡ:0
	}
	if(selector == 1)
	{
		output_high(pin_b2);
		delay_ms(50);
		output_low(pin_b1);
		output_low(pin_b3);
		output_low(pin_b4);
		bar_para = read_eeprom(0x2108);		//٥᡼١:63
		bar_offset = read_eeprom(0x2109);	//٥᡼եåȡ:0
	}
	if(selector == 2)
	{
		output_high(pin_b3);
		delay_ms(50);
		output_low(pin_b1);
		output_low(pin_b2);
		output_low(pin_b4);
		bar_para = read_eeprom(0x210a);		//٥᡼١:63
		bar_offset = read_eeprom(0x210b);	//٥᡼եåȡ:0
	}
	if(selector == 3)
	{
		output_high(pin_b4);
		delay_ms(50);
		output_low(pin_b1);
		output_low(pin_b2);
		output_low(pin_b3);
		bar_para = read_eeprom(0x210c);		//٥᡼١:63
		bar_offset = read_eeprom(0x210d);	//٥᡼եåȡ:0
	}
}


void select_disp(void)
{
	if(selector == 0)
	{
		lcd_cmd(0x80);
		eeprom_disp(0x2140);
	}
	if(selector == 1)
	{
		lcd_cmd(0x80);
		eeprom_disp(0x2150);
	}
	if(selector == 2)
	{
		lcd_cmd(0x80);
		eeprom_disp(0x2160);
	}
	if(selector == 3)
	{
		lcd_cmd(0x80);
		eeprom_disp(0x2170);
	}
}


void level_meter(void)
{
	int sig,cnt;

	sig = get_level(0);			//Lͥ:AN0
	bar_print(0, sig);

	sig = get_level(1);			//Rͥ:AN1
	bar_print(1, sig);

	for(cnt=0;cnt<200;cnt++)		//᡼α1
	{
		if(sw_check())break;
		delay_us(100);			//᡼α220ms
	}
	if(sw_check())break;
}


int get_level(int ch)
{
	float s,t;
	signed long u;
	int y;

	set_adc_channel(ch);
	delay_us(50);
	s = (read_adc()/bar_para)+1.0;			//ۡmax10
	t = log10(s);					//01ͤˤ
	u = (t*45)-bar_offset;				//ɽ˹碌45ܡʥեåȤˤޥʥˤʤ뤳ȤΤsigned)
	if(u <= 0)u = 0;				//Ū045
	if(u >= 45)u = 45;
	y = u;
	return(y);
}


void bar_print(int ch, sig)
{
	int i,j,k,m;

	i = sig/3;						//45ʤ15
	j = sig-(i*3);						//1ˤʤ
	k = 14 - i;						//ڡϺǤ1褵Τ15-1=14
	m = i;

	if(!ch)
	{
		lcd_cmd(0x80);					//1
		lcd_data(meter_car_f);				//1ʸ
	}
	else
	{
		lcd_cmd(0xc0);					//2
		lcd_data(meter_car_s);				//1ʸ
	}

	while(m--)lcd_data(0x02);				//mĤ"|||"񤭹ࡣ0ʤ񤭹ޤʤ

	if(i < 15)						//i=15ʤХڡ񤭹ޤʤ
	{
		if(j == 0)lcd_data(0x20);			//ڡ(̵Ǥ)
		if(j == 1)lcd_data(0x00);			//"|"
		if(j == 2)lcd_data(0x01);			//"||"
		while(k--)lcd_data(0x20);			//Ĥ򥹥ڡ
	}
}


void cg_write(void)
{
	int cnt;

	lcd_cmd(0x40);

	for(cnt=0;cnt<8;cnt++){printf(lcd_data,"%c",read_eeprom(0x2190+cnt));}	//0x00 1Υå
	for(cnt=0;cnt<8;cnt++){printf(lcd_data,"%c",read_eeprom(0x2198+cnt));}	//0x01 2Υå
	for(cnt=0;cnt<8;cnt++){printf(lcd_data,"%c",read_eeprom(0x21a0+cnt));}	//0x02 3Υå
	for(cnt=0;cnt<8;cnt++){printf(lcd_data,"%c",read_eeprom(0x21a8+cnt));}	//0x03 16ܥ塼٥ɽǻ
	for(cnt=0;cnt<8;cnt++){printf(lcd_data,"%c",read_eeprom(0x21b0+cnt));}	//0x04
	for(cnt=0;cnt<8;cnt++){printf(lcd_data,"%c",read_eeprom(0x21b8+cnt));}	//0x05
	for(cnt=0;cnt<8;cnt++){printf(lcd_data,"%c",read_eeprom(0x21c0+cnt));}	//0x06
	for(cnt=0;cnt<8;cnt++){printf(lcd_data,"%c",read_eeprom(0x21c8+cnt));}	//0x07

	lcd_cmd(0x80);
	lcd_clear();
}


void trans_rom(void)
{
	int i;

	for(i=0;i<6;i++){vol_code[i]=read_eeprom(0x2180+i);}		//ʸ󥳥ԡ
	sel_para = read_eeprom(0x2101);					//쥯
	shift_set =(read_eeprom(0x2105)*3);				//٥᡼ɽܹԥ󥿡
	vol_disp_sel = read_eeprom(0x2102);				//ܥ塼٥ɽˡ
	meter_car_f = read_eeprom(0x2103);				//٥᡼1ܤΥ饯
	meter_car_s = read_eeprom(0x2104);				//٥᡼2ܤΥ饯

}


void eeprom_disp(long add)
{
	int cnt,i;

	for(cnt=0;cnt<16;cnt++)
	{
		i = read_eeprom(add+cnt);
		if ((i == 0x00)||(i == 0xff))break;
		printf(lcd_data,"%c",i);
	}
	for(;cnt<16;cnt++)lcd_data(0x20);
}


void vol_char(void)
{
	int cnt,i;

	for(cnt=0;cnt<6;cnt++)
	{
		i = vol_code[cnt];
		if ((i == 0x00)||(i == 0xff))break;
		printf(lcd_data,"%c",i);
	}
}


void io_init(void)
{
	setup_adc(adc_clock_div_32);			//®ADC
	setup_adc_ports(san0|san1|vss_vdd); 		//ADCݡȻ
	set_tris_a(0b00000011);				//
	set_tris_b(0b11100000);				//
	set_tris_c(0b00000000);				//

	output_low(mute);				//졼:off---ǰΤ
	output_low(pin_b1);
	output_low(pin_b2);
	output_low(pin_b3);
	output_low(pin_b4);

	osccon = osc_8MHz;						//8MHzư

	setup_timer_0(rtcc_internal|rtcc_8_bit|rtcc_div_256);		//ޡ0
	set_timer0(0);
	enable_interrupts(global);					//ߵ

	lcd_init();		//lcd
	lcd_clear();	//lcdɽ򥯥ꥢˤ

	output_low(mute);						//졼:off---ǰΤ⤦
	output_low(pin_b1);
	output_low(pin_b2);
	output_low(pin_b3);
	output_low(pin_b4);

	output_high(vol_load);						//LM1972
	output_low(vol_clock);						//LM1972
	volume = 0;							//
	lm1972_data();							//ߥ塼

	if(! input(select_sw))eeprom_rw();

	cg_write();							//ꥸʥ륭饯
	trans_rom();							//eepromΥѥ᡼쥸˥ԡ
	selector = 0;							//괺Ϥ1˥åȤƤ
	lcd_clear();
}


void eeprom_rw(void)
{
	int add,dat,cnt;
	short set,exit;

	lcd_clear();
	cg_write();
	lcd_clear();
	lcd_cmd(0x80);
	printf(lcd_data,"EEPROM R/W Mode");
	while(! input(select_sw)){};
	exit = 0;
	add = 0;							//ɥ쥹
	cnt = 0;
	re_step = 0;
	delay_ms(2000);

	for(;;)
	{
		set = 0;
		lcd_clear();

		for(;;)												//addå
		{
			re_current = (input_b() & 0b11000000)>>6;						//꡼󥳡ɤ߹(bit7-6)
			if((re_previous == 0 && re_current == 1)|(re_current == 2 && re_previous == 3))		//cw
			{
				re_step++;
				if(re_step > 1)
				{
					re_step = 0;
					add++;
				}
			}
			if((re_current == 0 && re_previous == 1)|(re_previous == 2 && re_current == 3))		//ccw
			{
				re_step++;
				if(re_step > 1)
				{
					re_step = 0;
					add--;
				}
			}
			re_previous = re_current;
			lcd_cmd(0x80);
			printf(lcd_data,">ADD:21%X >>EXIT",add);

			dat = read_eeprom(0x2100+add);
			lcd_cmd(0xc0);
			printf(lcd_data," HEX:%X  ASCII:%c",dat,dat);

			if(! input(select_sw))							//**************************exitȤ߹Ԥ
			{
				delay_ms(50);
				if(input(select_sw))break;
				while(! input(select_sw))
				{
					delay_ms(20);
					cnt++;
					if(cnt>100)exit =1;
				}
				delay_ms(50);
				set = 1;
			}
			if(set)break;
		}

		if(exit)break;
		dat = read_eeprom(0x2100+add);							//ǰΤɤ߹
		set = 0;
		lcd_clear();
		lcd_cmd(0x80);
		printf(lcd_data," ADD:21%X",add);

		for(;;)
		{
			re_current = (input_b() & 0b11000000)>>6;						//꡼󥳡ɤ߹(bit7-6)
			if((re_previous == 0 && re_current == 1)|(re_current == 2 && re_previous == 3))		//cw
			{
				re_step++;
				if(re_step > 1)
				{
					re_step = 0;
					dat++;
				}
			}
			if((re_current == 0 && re_previous == 1)|(re_previous == 2 && re_current == 3))		//ccw
			{
				re_step++;
				if(re_step > 1)
				{
					re_step = 0;
					dat--;
				}
			}
			re_previous = re_current;
			lcd_cmd(0xc0);
			printf(lcd_data,">HEX:%X  ASCII:%c",dat,dat);

			if(! input(select_sw))
			{
				delay_ms(50);
				if(input(select_sw))break;
				while(! input(select_sw)){}
				delay_ms(50);
				set = 1;
			}
			if(set)break;
		}

		if(read_eeprom(0x2100+add) != dat)
		{
			write_eeprom(0x2100+add,dat);
			lcd_clear();
			cg_write();
			lcd_clear();
			lcd_cmd(0x80);
			printf(lcd_data," ADD:21%X  WATI!",add);
			lcd_cmd(0xc0);
			printf(lcd_data," HEX:%X  ASCII:%c",dat,dat);
			delay_ms(500);
		}
	}
}


void lcd_out(int code, int flag)
{
	PORTx = (PORTx & 0xF0) | ((code>>4) & 0x0F);

	if (flag == 0)
		output_high(RS);		//ɽǡξ
	else
		output_low(RS);			//ޥɥǡξ

	delay_cycles(1);			//NOP		
	output_high(EN);			//strobe out
	delay_cycles(2);
	output_low(EN);				//reset strobe
}


void lcd_data(int asci)
{
	lcd_out(asci, 0);			//̣ӥåȽ
	lcd_out(asci<<4, 0);			//̣ӥåȽ
	delay_us(50);
}


void lcd_cmd(int cmd)
{
	lcd_out(cmd, 1);			//̣ӥåȽ
	lcd_out(cmd<<4, 1);			//̣ӥåȽ
	if((cmd & 0x03) != 0)
		delay_ms(2);
	else
		delay_us(50);
}


void lcd_clear()
{
	lcd_cmd(0x01);				//ޥɽ
	delay_ms(15);
}


void lcd_init()
{
	delay_ms(30);
	lcd_out(0x30, 1);			//8bit mode set
	delay_ms(5);
	lcd_out(0x30, 1);			//8bit mode set
	delay_ms(1);
	lcd_out(0x30, 1);			//8bit mode set
	delay_ms(1);
	lcd_out(0x20, 1);			//4bit mode set
	delay_ms(1);
	lcd_cmd(0x2E);				//DL=0 4bit mode
	lcd_cmd(0x08);				//display off C=D=B=0
	lcd_cmd(0x0C);				//display on D=1 C=B=0
	lcd_cmd(0x06);				//entry I/D=1 S=0
	lcd_cmd(0x02);				//cursor home
}
